
/*====================================================================*/
/*  MouthxII.c  -- This file contains the data structures for the     */
/*                 vertical movement/images of the mouth.             */
/*====================================================================*/

#include <intuition/intuition.h>
#include "eyesII.h"

UWORD mouthx0_data[]={
/*-------------- plane 0 ---------------*/
0xfffe,0x3f80,0xffff,0x7f80,0xfeff,0xbf80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xff00,0x3f80,0xff9c,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 1 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xfeff,0xbf80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xfe00,0x3f80,0xffff,0xff80,0xffe3,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 2 -----------------*/
0x0000,0x0000,0x0000,0x0000,0x0100,0x4000,0x00c0,0xc000,
0x003f,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,
/*-------------- plane 3 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
};

/* Width in WORDS= 0x2HEX....2 decimal */

struct Image mouthx0_Image={
                           20,40,              /* LeftEdge, TopEdge */
                           0x19,             /* Width (in pixels) */
                           0x15,             /* Height */
                           0x4,              /* Depth */
                           &mouthx0_data[0], /* pointer to Image data */
                           0xf, 0,           /* PlanePick, PlaneOnOff */
                           &eyes0_Image      /*pointer to next image*/
                          };

UWORD mouthx1_data[]={
/*-------------- plane 0 ---------------*/
0xffff,0x1f80,0xffff,0xbf80,0xfeff,0xdf80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xfeff,0xdf80,0xff00,0x3f80,0xff9e,0x7f80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 1 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xfeff,0xdf80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xfeff,0xdf80,0xff00,0x3f80,0xffff,0xff80,0xffe1,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 2 -----------------*/
0x0000,0x0000,0x0000,0x0000,0x0100,0x2000,0x00c0,0xc000,
0x003f,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,
/*-------------- plane 3 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
};

/* Width in WORDS= 0x2HEX....2 decimal */

struct Image mouthx1_Image={
                           20,40,                /* LeftEdge, TopEdge */
                           0x19,               /* Width (in pixels) */
                           0x15,               /* Height */
                           0x4,                /* Depth */
                           &mouthx1_data[0],             /* pointer to Image data */
                           0xf, 0,             /* PlanePick, PlaneOnOff */
                           NULL                /*pointer to next image*/
                          };


UWORD mouthx2_data[]={
/*-------------- plane 0 ---------------*/
0xffff,0x1f80,0xffff,0xbf80,0xfeff,0xdf80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffbf,0x7f80,0xff80,0x7f80,0xffce,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 1 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xfeff,0xdf80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xff80,0x7f80,0xffc0,0xff80,0xffff,0xff80,0xfff1,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 2 -----------------*/
0x0000,0x0000,0x0000,0x0000,0x0100,0x2000,0x00c0,0xc000,
0x003f,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,
/*-------------- plane 3 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
};

/* Width in WORDS= 0x2HEX....2 decimal */




struct Image mouthx2_Image={
                          20,40,              /* LeftEdge, TopEdge */
                          0x19,             /* Width (in pixels) */
                          0x15,             /* Height */
                          0x4,              /* Depth */
                          &mouthx2_data[0], /* pointer to Image data */
                          0xf, 0,           /* PlanePick, PlaneOnOff */
                          NULL              /*pointer to next image*/
                          };


UWORD mouthx3_data[]={
/*-------------- plane 0 ---------------*/
0xffff,0x1f80,0xffff,0xbf80,0xfeff,0xdf80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffdf,0xff80,0xffa4,0xff80,
0xffff,0xff80,0xffe4,0xff80,0xffbf,0xbf80,0xff80,0x7f80,
0xffee,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 1 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xfeff,0xdf80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffe0,0xff80,0xffdb,0x7f80,
0xff80,0x3f80,0xff9b,0x3f80,0xffc0,0x7f80,0xffff,0xff80,
0xfff1,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 2 -----------------*/
0x0000,0x0000,0x0000,0x0000,0x0100,0x2000,0x00c0,0xc000,
0x003f,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,
/*-------------- plane 3 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffe0,0xff80,
0xffc0,0x7f80,0xffc0,0x7f80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
};

/* Width in WORDS= 0x2HEX....2 decimal */




struct Image mouthx3_Image={
                          20,40,              /* LeftEdge, TopEdge */
                          0x19,             /* Width (in pixels) */
                          0x15,             /* Height */
                          0x4,              /* Depth */
                          &mouthx3_data[0], /* pointer to Image data */
                          0xf, 0,           /* PlanePick, PlaneOnOff */
                          NULL              /*pointer to next image*/
                          };


UWORD mouthx4_data[]={
/*-------------- plane 0 ---------------*/
0xffff,0x1f80,0xffff,0xbf80,0xfeff,0xff80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffd2,0xff80,
0xffe4,0xff80,0xffe4,0xff80,0xff52,0x3f80,0xff3f,0xbf80,
0xff80,0x7f80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 1 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xfeff,0xff80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffc0,0xff80,0xffad,0x7f80,
0xff80,0x3f80,0xff00,0x3f80,0xffad,0xff80,0xffc0,0x7f80,
0xffff,0xff80,0xffe0,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 2 -----------------*/
0x0000,0x0000,0x0000,0x0000,0x0100,0x0000,0x00c0,0xc000,
0x003f,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,
/*-------------- plane 3 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffc0,0xff80,
0xffdb,0x7f80,0xff9b,0x7f80,0xffc0,0x7f80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
};

/* Width in WORDS= 0x2HEX....2 decimal */




struct Image mouthx4_Image={
                          20,40,              /* LeftEdge, TopEdge */
                          0x19,             /* Width (in pixels) */
                          0x15,             /* Height */
                          0x4,              /* Depth */
                          &mouthx4_data[0], /* pointer to Image data */
                          0xf, 0,           /* PlanePick, PlaneOnOff */
                          NULL              /*pointer to next image*/
                          };


UWORD mouthx5_data[]={
/*-------------- plane 0 ---------------*/
0xffff,0x1f80,0xffff,0xbf80,0xfeff,0xff80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffe4,0xff80,0xffff,0xff80,0xffe4,0xff80,
0xff64,0xff80,0xffe5,0xbf80,0xffa4,0xbf80,0xff9f,0x7f80,
0xffc0,0xff80,0xffee,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 1 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xfeff,0xff80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffe0,0xff80,0xffdb,0x7f80,0xff80,0x7f80,0xff80,0x3f80,
0xff80,0x3f80,0xff80,0x7f80,0xffdb,0x7f80,0xffe0,0xff80,
0xffff,0xff80,0xfff1,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 2 -----------------*/
0x0000,0x0000,0x0000,0x0000,0x0100,0x0000,0x00c0,0xc000,
0x003f,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,
/*-------------- plane 3 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffe0,0xff80,0xffc0,0xff80,0xffdb,0x7f80,
0xffdb,0x7f80,0xffda,0x7f80,0xffe0,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
};

/* Width in WORDS= 0x2HEX....2 decimal */




struct Image mouthx5_Image={
                          20,40,              /* LeftEdge, TopEdge */
                          0x19,             /* Width (in pixels) */
                          0x15,             /* Height */
                          0x4,              /* Depth */
                          &mouthx5_data[0], /* pointer to Image data */
                          0xf, 0,           /* PlanePick, PlaneOnOff */
                          NULL              /*pointer to next image*/
                          };


UWORD mouthx6_data[]={
/*-------------- plane 0 ---------------*/
0xffff,0x1f80,0xffff,0xbf80,0xfeff,0xff80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffc9,0xff80,0xffff,0xff80,0xffff,0xff80,0xfeff,0xbf80,
0xffc1,0xff80,0xfec9,0xbf80,0xfeeb,0xbf80,0xff49,0x7f80,
0xff3e,0x7f80,0xff41,0x7f80,0xffbe,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 1 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xfeff,0xff80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffc1,0xff80,
0xffb6,0xff80,0xff80,0xff80,0xff00,0x7f80,0xff00,0x7f80,
0xff00,0x7f80,0xff00,0x7f80,0xff00,0x7f80,0xffb6,0xff80,
0xffc1,0xff80,0xffbe,0xff80,0xffc1,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 2 -----------------*/
0x0000,0x0000,0x0000,0x0000,0x0100,0x0000,0x00c0,0xc000,
0x003f,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,
/*-------------- plane 3 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffc1,0xff80,0xffc1,0xff80,0xff80,0xff80,0xff80,0xff80,
0xffbe,0xff80,0xffb6,0xff80,0xff94,0xff80,0xffc1,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
};

/* Width in WORDS= 0x2HEX....2 decimal */

struct Image mouthx6_Image={
                          20,40,              /* LeftEdge, TopEdge */
                          0x19,             /* Width (in pixels) */
                          0x15,             /* Height */
                          0x4,              /* Depth */
                          &mouthx6_data[0], /* pointer to Image data */
                          0xf, 0,           /* PlanePick, PlaneOnOff */
                          NULL              /*pointer to next image*/
                          };


UWORD mouthx7_data[]={
/*-------------- plane 0 ---------------*/
0xffff,0x1f80,0xffff,0xbf80,0xfeff,0xdf80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffe4,0xff80,
0xffb3,0x7f80,0xfff7,0xff80,0xffff,0xff80,0xffff,0xdf80,
0xff88,0xff80,0xff88,0xdf80,0xff88,0x5f80,0xff40,0xff80,
0xff25,0x7f80,0xff9e,0xff80,0xffc1,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 1 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xfeff,0xdf80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffc0,0xff80,0xffbb,0x7f80,
0xff40,0xbf80,0xff00,0x3f80,0xff00,0x3f80,0xff00,0x3f80,
0xff00,0x3f80,0xff00,0x3f80,0xff40,0xbf80,0xff80,0x7f80,
0xffda,0xff80,0xffe1,0xff80,0xffff,0xff80,0xffe3,0xff80,
0xffff,0xff80,
/*-------------- plane 2 -----------------*/
0x0000,0x0000,0x0000,0x0000,0x0100,0x2000,0x00c0,0xc000,
0x003f,0x0000,0x0000,0x0000,0x0000,0x0000,0x0020,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,
/*-------------- plane 3 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffe0,0xff80,
0xff8c,0x7f80,0xff88,0x7f80,0xff80,0x7f80,0xff80,0x7f80,
0xfff7,0x7f80,0xfff7,0x7f80,0xffb7,0x7f80,0xffff,0xff80,
0xffe1,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
};

/* Width in WORDS= 0x2HEX....2 decimal */




struct Image mouthx7_Image={
                          20,40,          /* LeftEdge, TopEdge */
                          0x19,         /* Width (in pixels) */
                          0x15,         /* Height */
                          0x4,          /* Depth */
                          &mouthx7_data[0], /* pointer to Image data */
                          0xf, 0,       /* PlanePick, PlaneOnOff */
                          NULL          /*pointer to next image*/
                          };


UWORD mouthx8_data[]={
/*-------------- plane 0 ---------------*/
0xffff,0x1f80,0xffff,0xbf80,0xfeff,0xdf80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffff,0xff80,0xffe4,0xff80,
0xffb3,0x7f80,0xfff3,0xff80,0xffff,0xff80,0xfeff,0xdf80,
0xff88,0x7f80,0xfe88,0x5f80,0xfe88,0x5f80,0xff40,0xbf80,
0xff21,0x3f80,0xff9e,0x7f80,0xffc0,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 1 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xfeff,0xdf80,0xff3f,0x3f80,
0xffc0,0xff80,0xffff,0xff80,0xffc0,0xff80,0xffbb,0x7f80,
0xff40,0xbf80,0xff00,0x3f80,0xff00,0x3f80,0xff00,0x3f80,
0xff00,0x3f80,0xff00,0x3f80,0xff40,0xbf80,0xffa1,0x7f80,
0xffde,0xff80,0xffe1,0xff80,0xffff,0xff80,0xffe1,0xff80,
0xffff,0xff80,
/*-------------- plane 2 -----------------*/
0x0000,0x0000,0x0000,0x0000,0x0100,0x2000,0x00c0,0xc000,
0x003f,0x0000,0x0000,0x0000,0x0000,0x0000,0x0020,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,
/*-------------- plane 3 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffe0,0xff80,
0xff8c,0x7f80,0xff8c,0x7f80,0xff80,0x7f80,0xff80,0x7f80,
0xfff7,0xff80,0xfff7,0xff80,0xffb7,0x7f80,0xffde,0xff80,
0xffe1,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
};

/* Width in WORDS= 0x2HEX....2 decimal */




struct Image mouthx8_Image={
                          20,40,              /* LeftEdge, TopEdge */
                          0x19,             /* Width (in pixels) */
                          0x15,             /* Height */
                          0x4,              /* Depth */
                          &mouthx8_data[0], /* pointer to Image data */
                          0xf, 0,           /* PlanePick, PlaneOnOff */
                          NULL              /*pointer to next image*/
                          };


UWORD mouthx9_data[]={
/*-------------- plane 0 ---------------*/
0xffff,0x1f80,0xffff,0xbf80,0xfeff,0xff80,0xff3f,0x3f80,
0xff00,0x3f80,0xfeff,0xdf80,0xffff,0xff80,0xfdff,0xef80,
0xfdff,0xef80,0xfd84,0x6f80,0xfd04,0x2f80,0xfd04,0x2f80,
0xff84,0x7f80,0xfec4,0xdf80,0xfea1,0x5f80,0xfec1,0xff80,
0xff3e,0x3f80,0xff80,0x7f80,0xffde,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 1 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xfeff,0xff80,0xff3f,0x3f80,
0xffc0,0xff80,0xff00,0x3f80,0xfe00,0x1f80,0xfe00,0x1f80,
0xfe00,0x1f80,0xfe00,0x1f80,0xfe00,0x1f80,0xfe00,0x1f80,
0xfe00,0x1f80,0xff00,0x3f80,0xff40,0xbf80,0xff3e,0x3f80,
0xffc1,0xff80,0xffff,0xff80,0xffe1,0xff80,0xffff,0xff80,
0xffff,0xff80,
/*-------------- plane 2 -----------------*/
0x0000,0x0000,0x0000,0x0000,0x0100,0x0000,0x00c0,0xc000,
0x003f,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,
/*-------------- plane 3 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xffff,0xff80,0xff80,0x7f80,0xff00,0x3f80,
0xff00,0x3f80,0xff7b,0xbf80,0xfffb,0xff80,0xfffb,0xff80,
0xff7b,0xbf80,0xffbb,0x7f80,0xff9e,0x7f80,0xffc1,0xff80,
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
};

/* Width in WORDS= 0x2HEX....2 decimal */




struct Image mouthx9_Image={
                          20,40,              /* LeftEdge, TopEdge */
                          0x19,             /* Width (in pixels) */
                          0x15,             /* Height */
                          0x4,              /* Depth */
                          &mouthx9_data[0], /* pointer to Image data */
                          0xf, 0,           /* PlanePick, PlaneOnOff */
                          NULL              /*pointer to next image*/
                          };


UWORD mouthx10_data[]={
/*-------------- plane 0 ---------------*/
0xffff,0x1f80,0xfeff,0x9f80,0xff3f,0x3f80,0xff80,0x7f80,
0xff7f,0xbf80,0xfef3,0xff80,0xfdff,0xef80,0xfdff,0xef80,
0xfd84,0x6f80,0xfd04,0x2f80,0xfd04,0x2f80,0xfd04,0x2f80,
0xfd84,0x6f80,0xfec4,0xdf80,0xfec4,0xdf80,0xff61,0xbf80,
0xff21,0x3f80,0xff9e,0x7f80,0xffc0,0xff80,0xffed,0xff80,
0xffff,0xff80,
/*-------------- plane 1 -----------------*/
0xffff,0xff80,0xfeff,0xdf80,0xff3f,0x3f80,0xffc0,0xff80,
0xff80,0x7f80,0xff00,0x3f80,0xfe00,0x1f80,0xfe00,0x1f80,
0xfe00,0x1f80,0xfe00,0x1f80,0xfe00,0x1f80,0xfe00,0x1f80,
0xfe00,0x1f80,0xff00,0x3f80,0xff00,0x3f80,0xff80,0x7f80,
0xffde,0xff80,0xffe1,0xff80,0xffff,0xff80,0xfff3,0xff80,
0xffff,0xff80,
/*-------------- plane 2 -----------------*/
0x0000,0x0000,0x0100,0x2000,0x00c0,0xc000,0x003f,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,
/*-------------- plane 3 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xff8c,0x7f80,0xff00,0x3f80,0xff00,0x3f80,
0xff7b,0xbf80,0xfffb,0xff80,0xfffb,0xff80,0xfffb,0xff80,
0xff7b,0xbf80,0xffbb,0x7f80,0xffbb,0x7f80,0xffff,0xff80,
0xffe1,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
};

/* Width in WORDS= 0x2HEX....2 decimal */

struct Image mouthx10_Image={
                          20,40,               /* LeftEdge, TopEdge */
                          0x19,              /* Width (in pixels) */
                          0x15,              /* Height */
                          0x4,               /* Depth */
                          &mouthx10_data[0], /* pointer to Image data */
                          0xf, 0,            /* PlanePick, PlaneOnOff */
                          NULL               /*pointer to next image*/
                          };


UWORD mouthx11_data[]={
/*-------------- plane 0 ---------------*/
0xffff,0x1f80,0xfeff,0x9f80,0xff3f,0x3f80,0xff40,0xbf80,
0xfeff,0xdf80,0xfef7,0xdf80,0xfdff,0xef80,0xfdff,0xef80,
0xfdc4,0xef80,0xfd84,0x6f80,0xfd84,0x6f80,0xfd84,0x6f80,
0xfd84,0x6f80,0xfe84,0x5f80,0xfe84,0x5f80,0xff61,0xbf80,
0xff21,0x3f80,0xff9e,0x7f80,0xffc0,0xff80,0xffed,0xff80,
0xffff,0xff80,
/*-------------- plane 1 -----------------*/
0xffff,0xff80,0xfeff,0xdf80,0xff3f,0x3f80,0xff80,0x7f80,
0xff00,0x3f80,0xff00,0x3f80,0xfe00,0x1f80,0xfe00,0x1f80,
0xfe00,0x1f80,0xfe00,0x1f80,0xfe00,0x1f80,0xfe00,0x1f80,
0xfe00,0x1f80,0xff00,0x3f80,0xff40,0xbf80,0xff9e,0x7f80,
0xffde,0xff80,0xffe1,0xff80,0xffff,0xff80,0xfff3,0xff80,
0xffff,0xff80,
/*-------------- plane 2 -----------------*/
0x0000,0x0000,0x0100,0x2000,0x00c0,0xc000,0x003f,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
0x0000,0x0000,
/*-------------- plane 3 -----------------*/
0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,0xff88,0x7f80,0xff00,0x3f80,0xff00,0x3f80,
0xff3b,0x3f80,0xff7b,0xbf80,0xff7b,0xbf80,0xff7b,0xbf80,
0xff7b,0xbf80,0xfffb,0xff80,0xffbb,0x7f80,0xffe1,0xff80,
0xffe1,0xff80,0xffff,0xff80,0xffff,0xff80,0xffff,0xff80,
0xffff,0xff80,
};

/* Width in WORDS= 0x2HEX....2 decimal */

struct Image mouthx11_Image={
                            20,40,               /* LeftEdge, TopEdge */
                            0x19,              /* Width (in pixels) */
                            0x15,              /* Height */
                            0x4,               /* Depth */
                            &mouthx11_data[0], /* pointer to Image data */
                            0xf, 0,            /* PlanePick, PlaneOnOff */
                            NULL               /*pointer to next image*/
                           };

